<?php

// Array for traversal
$sample = ['vehicle'=>'car', 'animal'=>['dog', 'goat'], 'food'=>['egg', 'fruit'=>['apple', 'banana'], 'vegetable', 'cake'], 'planet'=>['Mars', 'Jupiter', 'Venus'], 'color'=>'blue'];

// 1st Demo
function recursive_1($value, $indent=-1) {
    if (is_array($value)) {  
        echo "\n";    
        foreach($value as $v) {
            recursive_1($v, $indent+1);
        }
    } else {
        $lead = str_repeat('   ', $indent);
        echo "$lead$value\n";
    }
}

// 2nd Demo
function recursive_2($value, $key="", $indent=-1) {
    if (is_array($value)) {
        if($key!="") {
            $lead = str_repeat('   ', $indent);
            echo "$lead$key =>\n";
        }    
        foreach($value as $k=>$v) {
            recursive_2($v, $k, $indent+1);
        }
    } else {
        $lead = str_repeat('   ', $indent);
        echo "$lead$key => $value\n";
    }
}

// 3rd Demo
function recursive_3($value) {
    array_walk_recursive($value, "show_data");
}

function show_data($value, $key) {
    echo "$key => $value\n";
}

// main
echo "\n******* recursive demo 1 *******\n\n";
recursive_1($sample);
echo "\n******* recursive demo 2 *******\n\n";
recursive_2($sample);
echo "\n******* recursive demo 3 *******\n\n";
recursive_3($sample);
